REM ---------------------------------------------------------------------------
REM  Trivadis - http://www.trivadis.com
REM ---------------------------------------------------------------------------
REM  Group/Privileges.: User
REM  Script-Name......: ex_index_rebuild.sql
REM  Developer........: Christian Antognini (christian.antognini@trivadis.com)
REM  Date.............: May 2011
REM  Version..........: Oracle Database 11g Release 1 and Release 2
REM  Description......: Up to 11.1 a rebuild does not save old statistics in 
REM                     the history.
REM  Usage............: 
REM                     
REM  Input parameters.: 
REM  Output...........: 
REM  Called by........:
REM  Requirements.....: 
REM  Remarks..........: 
REM ---------------------------------------------------------------------------
REM Changes:
REM DD.MM.YYYY Developer Change
REM ---------------------------------------------------------------------------
REM 24.05.2011 ChA       Added example with USE_INVISIBLE_INDEXES hint
REM 12.12.2011 ChA       Changed header
REM ---------------------------------------------------------------------------

SET ECHO ON TERMOUT ON SERVEROUTPUT OFF FEEDBACK OFF PAGESIZE 100 LINESIZE 80

CLEAR SCREEN

REM
REM Setup environment
REM

VARIABLE t varchar2(20)

DROP TABLE t PURGE;

CREATE TABLE t as SELECT rownum AS id FROM dual CONNECT BY level <= 1000;

CREATE INDEX i ON t (id);

INSERT INTO t SELECT rownum AS id FROM dual CONNECT BY level <= 1000;

COMMIT;

PAUSE

REM
REM
REM

execute SELECT to_char(systimestamp,'dd.mm.yyyy hh24:mi:ss') INTO :t FROM dual;

SELECT num_rows 
FROM user_indexes 
where index_name = 'I';

ALTER INDEX I REBUILD;

SELECT num_rows 
FROM user_indexes 
WHERE index_name = 'I';

exec dbms_stats.restore_table_stats(user,'t',to_date(:t,'dd.mm.yyyy hh24:mi:ss'))

SELECT num_rows 
FROM user_indexes 
WHERE index_name = 'I';

PAUSE

REM
REM Cleanup environment
REM

DROP TABLE t PURGE;
